/***********************************************************************
Try_mTIMEe.c                    (testowanie moduu mTIMEe z systemu LINUX)

Program zegara odmierzajcego czas liczony w sekundach. Jest to czas
uniwersalny liczony od 01/01/1970 roku. Dla jego przechowywania 
wystarczaj tylko 4-bajty (WORD32). Czas ten jednoznacznie wyznacza
dzie, miesic, rok oraz godziny, minuty i sekundy, a take dzie 
tygodnia. Program w przedstawionej wersji co sekund zwiksza czas
o jeden cay dzie plus 1 sekunda. Daje to moliwo udowodnienia 
poprawnoci dziaania wszystkich procedur zegara i kalendarza.

Program transmituje znaki przez zcze SIO parametrami:9600 bps (8-N-1). 
Program wymaga modelu LARGE podczas kompilacji.
***********************************************************************/
#include <LPC214x.H>   
#include <stdio.H>
#include "inttypes.h"                  // tu zdefiniowano BYTE, WORD i DWORD
#include "uart.h"
#include "mtime.h"

DWORD Sec_since1970;   // tu zliczane s sekundy zaczynajc od 1/01/1970
TM  TIME;                          // struktura przechowujca Dat i Czas

//----------------------------------------------------------------------
void main(void) { 
  char string[40];
  DWORD i;       
  UART_init;                                   // przygotowanie SIO
  printf("\nLINUX TIMEE test:");
        
  TIME.TM_dom=8;  
  TIME.TM_month=12 ;                      // !! miesic liczony jest od 0
  TIME.TM_year=2006;
	  					 
  TIME.TM_hour=23;
  TIME.TM_min=59;
  TIME.TM_sec=40;     
  Sec_since1970=TM_to_sec( &TIME );  
  printf("\n%ld ==\n",Sec_since1970 );       // pocztkowe ustawienie
 
  while (1){                           // drukowanie wynikw co 1sek.
    for( i=0;i<0x4fffff;i++ );                         // opnienie
    //Sec_since1970 ++;                         // zwiksz liczb sek.
                              // zwiksz liczb sek. o cay dzie +1sek.
    Sec_since1970 += 60*60*24L ;       // ... dla testowania programu
                                                 
    sec_to_TM(Sec_since1970,&TIME); // zamiana sek.-> Dat i Czas
    TM_to_string(&TIME,string);    // zamiana Daty i Czasu na ASCII
    printf("\n %s",string);             // drukowanie stringu ASCII

    printf("  == %d",Sec_since1970 - TM_to_sec(&TIME) );   // pocztkowe ustawienie                               
  }
}

