/**************************************************************************
GPIO.h                              ( obsuga bitw GPIO: LED, button etc.)

Zbir zawiera definicje obsugi bitw wyjcia (OUT) i wejcia (IN).
Pojedyncze bity oznaczono jako INP i OUT.  Grupy bitw oznaczono jako OUTs
(OUTPUTs). Pojedynczy bit jak i grupa bitw jest przesunita o liczb NBit
bitw. Maka M dotyczy grupy bitw. Przykadowo 0x7F oznacza grup 7-miu
bitw.
    NBit -  przesunicie 
    M    -  maska 
**************************************************************************/
#ifndef _GPIO_H_
#define _GPIO_H_

#include <INTTYPES.H>             //zbir definiujcy cakowite typy danych

// inicjowanie wyj ------------------------------------------------------
inline void OUTs_init ( uint8_t M, uint8_t NBit ) {       
  IODIR1 = IODIR1 | ( M << NBit) ; 
}                

// ustaw grup wyj wartoci x  -----------------------------------------
inline void OUTs_put ( uint8_t x, uint8_t M, uint8_t NBit ) { 
  IOPIN1 = ( IOPIN1 & ~( M  << NBit ) |  ( x & M ) << NBit) ; 
}

// ustawienie stanu 0 dla wyjcia -----------------------------------------
inline void OUT_clr ( uint8_t NBit ) {                   // wyzeruj wyjcie
  IOCLR1 = 1 <<  NBit  ;
} 

// ustawienie stanu 1 dla wyjcia ----------------------------------------- 
inline void OUT_set ( uint8_t NBit ) {                     // ustaw wyjcie
  IOSET1 = 1 <<  NBit  ;
}

// odczyt stanu wejcia ---------------------------------------------------
inline char INP_get( uint8_t NBit ) {
  return ( ( IOPIN1 & (1 << NBit  ) ) >>  NBit  );
}

// odczyt stanu grupy wej -----------------------------------------------
inline char INPs_get( uint8_t M, uint8_t NBit ) {
  return ( ( IOPIN1 & (M << NBit  ) ) >>  NBit  );
}

#endif // _GPIO_H_ 