/**********************************************************************
ADC_pooling.c                     (przetwornik AD w trybie odpytywania)

Program pokazuje obsug przetwornika pracujcego w trybie oczekiwania 
na zakoczenie przetwarzania. Odczytana warto z wejcia AIN0.1 
(P0.28) wywietlana jest na 8-miu diodach LED.
**********************************************************************/
#include <lpc214x.h>

int main(void){
  unsigned val;
  IODIR1 = 0x00FF0000;                // P1.16..23 pracuj jako wyjcia
  PINSEL1 = 0x01000000;                         // wybierz AD0 & AIN0.1
  AD0CR   = 0x00200402;                   // AD0: 10-bitw, AIN1 @ 3MHz        
  while(1){
    AD0CR  |= 0x01000000;                       //uruchom przetwarzanie
    do {
           val = AD0DR1;                  // odczytaj A/D Data Register
    }        
    while ((val & 0x80000000) == 0); //czekanie na koniec przetwarzania
    val = ((val >> (6+2)) & 0xFF)<<16;        //wyuskaj wynik 8-bitowy
    IOCLR1 = val;                       //wywietl wynik na diodach LED
    IOSET1 =~val;
  }
}
