/**********************************************************************
DA_chirp.c                           (przetwornik AD i generator chirp)

Program pokazyj obsug przetwornika Cyfrowo Analogowego DAC. Program
generuje sygna o zmiennej czstotliwoci typu chirp. Sygna dostpny 
jest na wyjciu AOUT (P0.25).
**********************************************************************/
#include <lpc214x.h>
#include <math.h>

#define N (1<<5)          // liczba prbek sygnau sinus w postaci 2**N

void main(void){
  unsigned samples[N];                  // tablica prbek funkcji sinus
  unsigned i,delay,val;
  PINSEL1 = 1<<19;                                // wybierz DAC (AOUT)   
  // przygotowanie tablicy prbek 10-cio bitowych jako liczby bez znaku
  for(i=0;i<N;i++)  samples[i]=511*sin(2* 3.1415926*i/(float)(N))+ 512;

  while(1){
    i=(i+1) & (N-1) ; // aby indeks nie by wikszy ni rozmiar tablicy
    DACR=( samples[i] & 0x3ff )<<6;     // prbki przesunite o 6-bitw
    if (i==0) val= (val+1) & 0x3ff;     // zwikszanie czasu opnienia
    for (delay=0;delay<val;delay++);                 // czas opnienia
  }
}