/*********************************************************************
SPI_test.c                (test interfejsu SPI w procesorach '21xx)

Po poczeniu przewodem wyprowadze procesora MISO i MOSI mona
przeprowadzi test dziaania zcza SPI. Interfejs
SPI jednoczenie transmituje i odbiera bajty danych. Poczenie 
przewodem linii MOSI I MISO spowoduje, e ten wysyany bajt bdzie 
jednoczenie odbierany. Gdyby odebrano inny bajt ni nadany lub 
pojawi si bd transmisji program zostanie zakoczony z 
komunikatem o bdzie.
Wyniki programu wyprowadzane s na zcze SIO z parametrami 38400bps
8-N-1. Procesory '214x posiadaj dwa rne ukady SPI oznaczone SPI0
i SPI1. Doczajc do projektu zbiory SP0_hard.c lub SP0_hard.c mona
przetestowa dziaanie ukadw SPI0 i SPI1 z hardware'owym 
wspomaganiem dziaania transmisji SPI. Zbir SPI1_soft.c zawiera
procedury sofrware'owe  do obsugi transmisji SPI za pomoc 
sterowania linii GPIO.
*********************************************************************/
#include <LPC214X.H>                       // rejestry procesora '214x
#include <stdio.H>
#include <string.H>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "spi.h"                     // podstawowe funkcje obsugi SPI
#include "uart.h"

// -------------------------------------------------------------------
void main(void) {
  BYTE x,i;
  BYTE send[15], receive[15];
  for(i=0;i<15;i++) send[i]=i;
  UART_init;   
  SPI_Init();                                     // przygotowanie SPI
  printf("\n\nSPI test\n");
 
  SPI_Byte(0x01);                   // wysanie bajtu 0x01 bez odbioru
  SPI_Data( receive,send, 15 );      // wysanie i odbir cigu bajtw
  if( strncmp (send, receive, 15)) printf ("\n DIFFERENCES  \n");

  printf("\n Writing 0..255\n");    
  for (i=0 ; i<255 ; i++ ) {         // nadawanie i odbir 0x00...0xFF
       if ( (x=SPI_Byte(i) ) != i ) printf(" SPI error \n");    
       printf("%02x ",x); 
       if((i & 0xF)==15 ) putchar ('\n');
    }
   
}