/*********************************************************************
keyb_to_LCD_buff.c     (pobieranie danych z klawiatury z buforowaniem)     

Program pozwala wprowadza dane z klawiatury z moliwoci kasowania
za pomoc klawisza backspace. Program pozwala zobaczy jak odbywa si
wprowadzanie tekstu z poprawianiem oraz jak dziaa wprowadzanie
dwch liczb typu float po to aby je doda do siebie. W programie 
uywa si funkcji ssanf z biblioteki stdio.h.
*********************************************************************/
#include <LPC214x.H>                      //zbir definiujcy rejestry
#include <stdio.h>
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "LCD4bit.h"                                
#include "KEYB.h"                     // biblioteka funkcji klawiatury       
                                   //... mona take wyprbowa UART.h
 
#define CharNo   NB_COL+1        // NB_COL liczba znakw w wierszu LCD

void getline (char *line_buf, BYTE n);           // prototyp procedury
                                           //... pobrania linii tekstu
char line_buf[CharNo];                        // bufor na lini tekstu
//--------------------------------------------------------------------
void main(void) {
  char t[CharNo];                                            // string
  float f,g;                                      // dwie liczby float
                                
   KEYB_init;                         // przygotowanie klawiatury KEYB
   LCD_init;                                      // przygotowanie LCD
   printf("\nLine Buffer-----"); 
    
cont: 
   putchar('\n');                           
   getline(line_buf, CharNo);               // pobieranie linii tekstu

   sscanf(line_buf,"%s", t );      // interpretacja danych jako string
   printf("\nStr:%s",t); 

   //sscanf(line_buf,"%f %f", &f,&g);     // interpretacja danych jako
   //printf("\n+= %12.3g",f+g);                  //...dwie liczy float
   goto  cont;                        // mao eleganckie ale skuteczne
}

//--------------------------------------------------------------------                                                                      
// Pobranie jednej linii tekstu z moliwoci edycji znakw               
//------------------------------------------------------------------- 
void getline (char  *line_buf, BYTE n)  {
  BYTE cnt = 0 ;   
  char c,pp,nn;             // pp - poprzedni znak ; nn -nastpny znak

  do  {
    c = _getkey ();                                  // pobranie znaku
    pp=nn;   
    nn=c;
    if(c=='\n') c='\r';

 
   if (c == '\t' ) {
        putchar (' ');                // wyprowadzenie znaku backspace
        putchar ('\b');
   }
   else
   if (c == '\b' )  {                       // obsuga znakw bakspace
      if (cnt > 0)  {            
        cnt--;                         // zmniejszenie licznika znakw
        line_buf--;          // zmniejszenie wskanika biecego znaku
        putchar ('\b');               // wyprowadzenie znaku backspace
        putchar (' ');
        putchar ('\b'); 
     }
   }
   else  {                                   
      putchar (*line_buf = c);       // echo znaku i skadowanie znaku
      line_buf++;              // zwikszenie wskanika znakw w linii
      cnt++;                            // zwikszenie licznika znakw
   }
  }  while (cnt < n - 1  &&  c != '\r');  // sprawdzenie limitu znakw
  *line_buf = 0;           // znak 0 (NULL) jest ogranicznikiem znakw
} 