/*********************************************************************
hex_cnv.c                                             (konwersja  HEX)

Biblioteka procedur konwersji HEX <-> BYTE 
*********************************************************************/
#include <LPC214x.H> 
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD

//------------- konwersja znakw '0'..'F' na czterobitowe liczby  0..F
BYTE Hex2Nible(BYTE c) {

  if(c>='0' && c<='9') return(c - '0');
  if(c>='A' && c<='F') return(c - 'A' + 10);
  return 0;
}

//------------- konwersja liczb czterobitowych 0..F do znakw '0'..'F'
char Nible2Hex(BYTE d) {

  if( d<10          )  return('0' + d);
  if( d>=10 && d<=15)  return('A' + (d - 10) );
  return ('?');
}

//---------------------------- zamiana bajtu na 2 znaki heksadecymalne
void Byte2Hex(BYTE c, char *s) {

   *s++ = Nible2Hex((c & 0xf0) >> 4); 
   *s   = Nible2Hex( c & 0x0f); 
}

//----------------------------------- zmiana 2 znakw hex na jeden bajt
BYTE Hex2Byte(char *s) { 

  return ( Hex2Nible(*s)<<4) + Hex2Nible(*(s+1));
}