/*--------------------------------------------------------------------
RLTREGS.h                       (zbir definicji rejestrw ukadu NIC)

Rejestry ukadu Realtek RTL8019AS. Ukad ten moe pracowa w trybie
zgodnym ze standardem kontrolera NE2000.Ukad RTL8019AS jest 
zintegrowan i unowoczenion postaci wczeniejszego zestawu ukadw 
DP8390D firmy National.
--------------------------------------------------------------------*/
#ifndef RTLREGS_H_
#define RTLREGS_H_

#define CMD        0x00                            // Command Register
#define IOPORT     0x10                               // I/O Data Port
#define RESET      0x1f                                  // Reset Port

//  Page 0 registers -------------------------------------------------
#define P0_PSTART 0x01              // Page Start Register for receive
#define P0_PSTOP  0x02               // Page Stop Register for receive
#define P0_BNRY   0x03                 // Boundary Pointer for receive
#define P0_TPSR   0x04                  // Transmit Page Start address
#define P0_TBCR0  0x05             // Transmit Byte Count register low
#define P0_TBCR1  0x06            // Transmit Byte Count register high
#define P0_ISR    0x07                    // Interrupt Status Register
#define P0_RSAR0  0x08            // Remote Start Address register low 
#define P0_RSAR1  0x09           // Remote Start Address register high
#define P0_RBCR0  0x0a               // Remote Byte Count register low
#define P0_RBCR1  0x0b              // Remote Byte Count register high
#define P0_RCR    0x0c               // Receive Configuration register
#define P0_RSR    0x0c                      // Receive Status register
#define P0_TCR    0x0d              // Transmit Configuration register
#define P0_DCR    0x0e                  // Data Configuration register
#define P0_IMR    0x0f                      // Interrupt Mask register

// Page 1 registers --------------------------------------------------
#define P1_PAR0   0x01             // Physical Address registers 0...5
#define P1_CURR   0x07      // Current Page register (the next packet)
#define P1_MAR0   0x08             // Multicast Address register 0...7

#endif	 // -------------------------------------------------RTLREGS_H_