;**********************************************************************
; led_cnt.s                                         (mruganie diod LED)
;
; Przykadowy program w jzyku asembler w trybie ARM procesora LPC2138.
; Program powoduje mruganie 8-miu diod LED (licznik binarny). 
; Wykorzystano 32-bitowy licznik binarny, ktrego bity 23...16 steruj
; diodami LED. Dziki temu nie ma potrzeby stosowania opnienia
; czasowego.
;**********************************************************************

	   ARM
       AREA   STARTUPCODE, CODE         ; kod programu zaczyna si od 0
	   ENTRY
	   EXPORT 	Reset_Handler
       B        Reset_Handler 
       SPACE 7*4                           ; wektory zdarze (przerwa)
                       
Reset_Handler
       LDR R0, =(0xff<<16) ; diody LED podczone od bitu 16 poczynajc
       LDR R1, =0xE0028000            ; ustawienie adresu bazowego w R1
       STR R0,[R1,#0x18]            ; zapis R0 do IODIR1 - kierunek OUT

loop   mov R0, #(0xff<<16)
       STR R0,[R1,#0x14]          ; zapis R6 do IOSET1 - zgaszenie diod
       
       ADD R2,R2,#1                         ; 32-bitowy licznik binarny
       STR R2,[R1,#0x1C]          ; zapis R6 do IOCLR1 - zapalenie diod

       B   loop                                       ; ptla bez koca

       END