/**********************************************************************
NIRQ.c                 (przerwanie niewektorowe - non vector interrupt)
                                      
Program ilustruje uycie przerwa niewektorowych. rdem przerwa jest
przycisk podczony do linii EINT1.     
Program ilustruje uycie przerwania zewntrznego wyzwalanego poziomem.
Program gwny pokazuje na czterech diodach LED (OUTs) stany licznika
binarnego. Przycinicie przycisku przerwania powoduje mruganie 
czterech innych diod LED tak dugo dopki przycinity jest przycisk 
przerwania.
**********************************************************************/
#include <LPC213x.H>            // zbir definiujcy rejestry procesora
#include "GPIO.h"                // biblioteka funkcji obsugi diod LED
void delay(int);                              // prototyp funkcji delay
void NonVectoredIRQ (void) __irq;          // prototyp obsugi przerwa

//---------------------------------------------------------------------
int main(void) { 
  char x=0x00;                // zmienna przechowujca warto licznika
  PINSEL0 = 0x20000000;             // ustawienie pinu P0.14 jako EINT1
  VICDefVectAddr=(unsigned)NonVectoredIRQ;        // przypisanie adresu
  VICIntEnable= 0x00008000;            // odblokowanie przerwania EINT1
  OUTs_init(0xff, 16);                            // inicjacja diod LED

  while (1) {                                        // ptla bez koca
     delay(1);                                    // opnienie czasowe
     OUTs_put(x++,0xf,16);          // wywietlenie licznika na diodach
  }
}

// podprogram opnienia-----------------------------------------------
void delay(int s){
  int i;
  for(i=0;i< (s* 0xfffff);i++);  
}

//podprogram obslugi przerwania ---------------------------------------
 __irq void NonVectoredIRQ (void)	 {	
  static char x=0x00;         // zmienna przechowujca warto licznika
  if(VICIRQStatus&0x00008000) {        // sprawdzanie rda przerwania
    delay(1);                                     // opnienie czasowe
    OUTs_put(x++,0xf,20);           // wywietlenie licznika na diodach
    EXTINT= 0x00000002;                   // zerowanie flagi przerwania
  }
  VICVectAddr = 0x00000000;        // zerowanie Vector Address Register
}
