/**********************************************************************
SWI_test.c                                   (przerwanie software'owe - swi)
                                      
Program ilustruje uycie przerwa software'owych SWI. W programie 
zdefioniowano dwa przerwania wywoywane w programie. Przerwania 
maj swoje numery identyfikujce. Kade z przerwa moe mie inn
list parametrw. W wyniku dziaania programu na diodach LED widoczny
jest efekt typu maszerujce wojsko.
Do programu naley doczy modu w jzyku asembler SWI_VECT.s.
Uycie przerwa software'owych w programie bez systemu operacyjnego nie
ma adnych zalet poza wartoci poznawcz. 
**********************************************************************/
#include <LPC214x.H>            // zbir definiujcy rejestry procesora
#include "GPIO.h"                // biblioteka funkcji obsugi diod LED
void delay(int);                              // prototyp funkcji delay
void  __swi(0)  swiCall0(char pattern);
void  __swi(1)  swiCall1(void) ;

//---------------------------------------------------------------------
int main(void) {

  OUTs_init(0xff, 16);                            // inicjacja diod LED

  while (1) {                                        // ptla bez koca
    delay(1);                                     // opnienie czasowe
    swiCall0(0xf0);                        // wywoanie przerwania SWI

    delay(1);                                     // opnienie czasowe
    swiCall1();                            // wywoanie przerwania SWI
  } 
}

// podprogram opnienia-----------------------------------------------
void delay(int s){
  int i;
  for(i=0;i< (s* 0xfffff);i++);  
}

//podprogram obslugi przerwania SWI -----------------------------------
void __SWI_0  (char pattern) {    // przerwanie z parametrem 1
  OUTs_put(pattern,0xff,16);        // wywietlenie zawartoci licznika
}

//podprogram obslugi przerwania SWI -----------------------------------
void  __SWI_1  (void)   {       // przerwanie z parametrem 3
  OUTs_put(0x0f,0xff,16);          //  wywietlenie zawartoci licznika
}
