/*********************************************************************
P_DOWN.c                                 (prosty przykad POWER DOWN)

Program demonstruje uycie energooszczdnego trybu POWER DOWN 
mikrokontrolera. Do wyprowadzenia procesora ze stanu P_DOWN mona 
uy dowolnego przerwania zewntrznego, w tym przypadku przerwania 
EINT1 (P0.14). Procedura przerwania nie jest konieczna do wyjcia
ze stanu P_DOWN. W stanie P_DOWN wieci co druga dioda LED portu P1.
*********************************************************************/
#include <lpc214x.h>

#define NBit_LED  16                      // przesunicie dla diod LED
#define M         0xFF                      //maska dla 8-miu diod LED

#define LEDs_init IO1DIR = M << NBit_LED

void PLL0_MAM_VPBDIV_init (void);

__inline void LEDs_put(char x) {     //-------------------------------
  IO1CLR = ( ~x & M ) << NBit_LED ; 
  IO1SET = (  x & M ) << NBit_LED ; 
}

__inline void delay(void) {          //-------------------------------
   unsigned j;
   for(j = 0; j < 0x100000; j++) ;
}

//--------------------------------------------------------------------
main(void) {
int i;
LEDs_init;                                   // inicjalizacja diod LED

PINSEL0 = 2 << 28;                           // wybranie pinu do EINT1
INTWAKE = 2;
PCONP= 0;

  while(1) {
    for(i=1;i<0x200;i<<=1) {
    LEDs_put(~i);              // wywietlenie zawartoci x na diodach
    delay() ;                                    // opnienie czasowe
    }
    LEDs_put(0x55);
    EXTINT = 2;
    PCON = 2;                   // przejcie do trybu power POWER DOWN
    delay();                                     // opnienie czasowe
    //PLL0_MAM_VPBDIV_init ();
  }
}

//--------------------------------------------------------------------
void PLL0_MAM_VPBDIV_init (void) {
    PLL0CFG  =0x24;                                  // MSEL=5, PSEL=2
    PLL0CON  =0x01;                       // PLLE Enable: odblokowanie
    PLL0FEED =0xAA;               // Feed sequence: sekwencja startowa
    PLL0FEED =0x55;               //...
    while (! ( PLL0STAT & 0x400) );      // wait for PLOCK bit: czekaj
    PLL0CON  =0x03;  // PLLE Enable and PLLC Connect:odblokuj i docz
    PLL0FEED =0xAA;               // Feed sequence: sekwencja startowa
    PLL0FEED =0x55;               //...

    VPBDIV   =0;                               // PCLK set: ustaw PCLK

    MAMCR    =0;                    // MAM Disable: zablokuj dziaanie
    MAMTIM   =4;                            // MAM Timinng; wyprbuj 1
    MAMCR    =2;     // MAM Fully Enabled: przyspieszacz pamici FLASH
}
