/*****************************************************************
UART.c                       (biblioteka transmisji UART1 i UART0)

Biblioteka funkcji STDIO wymaga aby byy zdefiniowane procedury
_getkey i putchar. Jeli te procedury bd dotyczy transmisji
UART to funkcje printf i scanf bd wyprowadza wyniki na 
zcze UARTT. O wyborze kanau transmisji decyduj definicja
UART 0/1 w zbirze UART.h. 
*****************************************************************/
#include <LPC214x.H>      // zbir definiujcy rejestry procesora
#include "UART.h"      // zbir makrodefinicji przygotowania UART

#if  UART //=====================================================
//-------------------------- nadawanie znaku poprzez zcze UART1
 int sendchar(int ch) {                
    do { } while (!(U1LSR & 0x20));       // czekanie na gotowo
    return (U1THR = ch);                        // wysanie znaku
}

 int getkey(void) {
   do { } while (!(U1LSR & 0x01));
  return (U1RBR);                                 // odbir znaku
}
#else     //=====================================================
//-------------------------- nadawanie znaku poprzez zcze UART0
 int sendchar(int ch) {                
    do { } while (!(U0LSR & 0x20));       // czekanie na gotowo
    return (U0THR = ch);                        // wysanie znaku
}

//-------------------------      odbir znaku poprzez zcze UART
 int getkey(void) {
    do { } while (!(U0LSR & 0x01));       // czekanie na gotowo
    return (U0RBR);                               // odbir znaku
}  
#endif    //=====================================================
