//--------------------------------------------------------------------
// KEYB.c                       (modu obsugi klawiatury skaningowej)
//
// Procedura _getkey przystosowana do  obsugi klawiatury 
// telefonicznej o 12-tu klawiszach. Procedura _getkey uywa procedury
// scan do sprawdzania stanu klawiatury.
//       _______  
//      | 1 2 3 |
//      | 4 5 6 |
//      | 7 8 9 |
//      | * 0 # |
//       _______
//
//--------------------------------------------------------------------
#include <LPC214x.H>      //zbir definiujcy rejestry mikrokontrolera
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD
#include "keyb.h" 

// obsuga klawiatury ------------------------------------------------
BYTE scan(void ) {                // skanowanie jednokrotne klawiatury
  const BYTE toASCII[2][4][3]=    // zamiana kodw klawiatury na ASCII
 {
     {        
          {'+'     ,    '-'  ,   '*'     },
          {'/'     ,    '&'  ,   '|'     },
          {'x'     ,    0x1b ,   'e'     },                 //1B - ESC
          {' '     ,    '.'  ,   '\r'    },           //SPACE, '.', CR
     },
     {        
          {'1'     ,    '2'  ,   '3'     },
          {'4'     ,    '5'  ,   '6'     },
          {'7'     ,    '8'  ,   '9'     },
          {'\b'    ,    '0'  ,  '\t'     },             //BS, '0', TAB
     },
 };
 BYTE i,j,l,msk,mskr,kbd;
 msk  = 0x01;
 for(j=0;j<4;j++) {
   DELAY;
   KBD_OUT (~msk);                     //pobudzenie wiersza klawiatury
   mskr = 0x01;
   for(i=0;i<3;i++) {
      kbd = KBD_IN() & mskr;               //odczyt kolumny klawiatury
      if(!kbd)  { 
          l=SHIFT;
          return (toASCII[l][j][i]);
      }
      mskr <<= 1; 
   }  
   msk <<=  1;
 }
 return 0xff;                       // nie nacinito adnego klawisza
}

// ------------------- funkcja zgodna ze standardem biblioteki stdio.h
int getkey(void) {   // czekanie na nacinicie i zwolnienie klawisza
 BYTE k,k1;
 WORD l;
 while(1) { 
   k = scan();
   if( k != 0xff) {                         //jeli nacinito klawisz
     do {
       DELAY;
       k1 = scan();                //sprawdzenie czy zwolniono klawisz
     } while( k1 != 0xff);
   return(k);
   }
 }
}
