// -------------------------------------------------------------------
// zbir : KEYB.h
// Zbir zawiera definicje umoliwiajce klawiatury telefonicznej
// Przed yciem klawiatury naley wywoa makrodefinicj KEYB_init
// -------------------------------------------------------------------
#include <LPC214x.H>      //zbir definiujcy rejestry mikrokontrolera
#include "inttypes.h"            // tu zdefiniowano BYTE, WORD i DWORD

#ifndef _KEYB_H_
#define _KEYB_H_

#define NBit_KBD_OUT    28      // przesunicie dla 4-ch bitw wierszy
#define NBit_KBD_IN     10                     //pooenie 3-ch kolumn
#define NBit_SHIFT_IN   13                   //pooenie przycisku BUT
#define M               0xFu                    //maska dla 4-ch bitw

#define SHIFT  ( IO0PIN & (1<<NBit_SHIFT_IN))>>NBit_SHIFT_IN;
#define KBD_OUT_init IO1DIR |= IO1DIR | (M << NBit_KBD_OUT ) // OUTPUT
          
// podprogram steruje stanem wierszy klawiatury ----------------------
__inline void KBD_OUT( BYTE x) {
  IO1CLR = ( ~x & M ) << NBit_KBD_OUT;   // zerowanie wskazanych bitw
  IO1SET = (  x & M ) << NBit_KBD_OUT;  // ustawianie wskazanych bitw
}

// podprogram sprawdzanie stan kolumn klawiatury  --------------------
__inline  BYTE  KBD_IN (void ) {                          
  return( (IO1PIN & ( M<< NBit_KBD_IN  ) ) >> NBit_KBD_IN); // 0 lub 1
}   

#define DELAY for(l=0;l<250;l++)                         // opnienie

#define KEYB_init   KBD_OUT_init           // inicjowanie KEYB  makro
extern int getkey(void);
#endif // _KEYB_H_
