/**********************************************************************
try_crc_modyfied.c               (sprawdzenie dziaania mechanizmu CRC)
                                             ... modyfikacja algorytmu
Program oblicza 16-bitow sum CRC. Suma ta dopisywana jest na
kocu acucha znakw str. Jeli policzy jeszcze raz CRC razem z 
dopisanym CRC, to wynik powinien by rwny 0.Wyniki oblicze przesyane
s na zcze SIO: 9600bps (8-N-1).
Wynik CRC zaley od algorytmu (LSFR Galois), wielomianu CRC 
//(CRC-16: X^16+X^15+X^2+1), wartoci pocztkowej CRC (0xFFFF),
miejsca wczenia strumienia bitowego (po bicie Q15).
**********************************************************************/
#include <LPC214x.H>       //zbir definiujcy rejestry mikrokontrolera
#include <stdio.h>
#include "inttypes.h"             // tu zdefiniowano BYTE, WORD i DWORD
#include "UART.h"

BYTE str[]= {1,2,3,4,  0,0}; // przyadowy cig bajtw i miejsce na CRC

#define Polynom      0xA001 // CRC-16: X^16+X^15+X^2+1         
//#define Polynom    0xD008 // XILINX: X^16+X^12+X^3+X^1+1     
//#define Polynom    0x8408 // CRC-CCITT: X^16+X^12+X^5+1      

// Obliczanie CRC. Parametry: bufor, dlugo bufora ------------------
WORD calcCRC( unsigned char* cBuffer, int iBufLen ) {
 int  i, j;
 WORD wCrc = 0xFFFF;                // warto pocztkowa (reset,seed)
 for(i=0;i<iBufLen;i++) {
   wCrc ^= cBuffer[i];   // pobranie kolejnego bajtu do obliczenia CRC
   for(j=0; j<8; j++) {
	 if( wCrc & 0x0001  )  wCrc = (wCrc >> 1) ^ Polynom;
		                                        else  wCrc = wCrc >> 1;
   }
 }
 return wCrc;
}

//---------------------------------------------------------------------
main(void) { 
     WORD x;
     BYTE i;
     UART_init;                                   // przygotowanie SIO
     x=calcCRC(str, (sizeof str) -2);                 // obliczenie CRC
     str[(sizeof str) -2]= x ;                   // dopisanie CRC (low)
     str[(sizeof str) -1]= x >>8;               // dopisanie CRC (high)
              // oblicznie CRC razem z tym co zostao dopisane na kocu
                                       //... wynik powinien by rwny 0
     printf("\rCRC= %x\r", calcCRC(str,sizeof str) );
     for(i=0;i<sizeof str;i++) printf("%02x ",str[i]);
     while(1);
 }


