// -------------------------------------------------------------------
//   1_WIRE.h
//
// Definicje procedur obsugi termometru DS1820 typu 1-wire
// ---------------------------------- --------------------------------
#ifndef _1_WIRE_H_
#define _1_WIRE_H_

#define NBit_WIRE1    12      // numer bitu gdzie podczono termometr

#define WIRE1_out  (IO0DIR  |=   1 << NBit_WIRE1 )        // nadawanie
#define WIRE1_in   (IO0DIR  &= ~(1 << NBit_WIRE1))           // odbir

//Polecenia sterujce WIRE1 ------------------------------------------
#define WIRE1_clr  IO0CLR = 1 << NBit_WIRE1         // wyzeruj  1-wire
#define WIRE1_set  IO0SET = 1 << NBit_WIRE1           // wcz  1-wire
#define WIRE1_get  (IO0PIN & ( 1 << NBit_WIRE1 ) ) >> NBit_WIRE1   

char WIRE1_read_byte(void);                     // odczyt bajtu informacji
char WIRE1_write_byte(char data);            // zapis bajtu informacji
char WIRE1_present(void);          // impuls start i czekanie na odpowied
void  delay_us(unsigned n);        // czas opnienia w mikrosekundach

#endif // _1_WIRE_H_
